#ifndef gDIR_REC_X_H
#define gDIR_REC_X_H

#include "glist.h"
#include "ghash.h"
#include "gfilestat.h"
////////////////////////////////////////////////////////////
struct sDuOpt {
    sDuOpt ()
	: viewMask( 0 ),
	  zValue( 0 ),
	  sortCode( 1 ),
	  doShowAll( false ),
	  doExact( false ),
	  doSummarize( false ),
	  doByBlockSize( false ),
	  doByByteSize( false ),
	  doByMegaBytes( false ),
	  doCountHardLinks( false ),
	  doSupportLL( true ),
	  doSupportInode( true ),
	  aMaxDepth( -1 ),
	  numMaxDigits( 10 ) {
    }

    int viewMask;
    int zValue;
    int sortCode;  // 1: normal sort
    bool doShowAll;
    bool doExact;
    bool doSummarize;
    bool doByBlockSize;
    bool doByByteSize;
    bool doByMegaBytes;

    bool doCountHardLinks;
    bool doSupportLL;
    bool doSupportInode;
    int aMaxDepth;
    unsigned numMaxDigits;

    gString sFmtBasicDigits;  //sFmtBasicDigits( (char*)"\0" ) -> empty string (or "-"...)

    unsigned GetMaxDigits () {
	return numMaxDigits;
    }
};
////////////////////////////////////////////////////////////

extern int gdr_strip_name (int stripLevel,
			   int fallback,
			   char slashChr,
			   gString& sNew) ;

extern char* gdr_strip_name_str (char* str,
				 int stripLevel,
				 gString& sName) ;

////////////////////////////////////////////////////////////

extern int gdr_du_dir (char* str,
		       FILE* fOut,
		       FILE* fRepErr,
		       gHashTriple& myHash,
		       sDuOpt& duOpt,
		       int verboseLevel,
		       t_uint64& byteSize,
		       t_uint64& blockSize,
		       int stripLevel,
		       int& recControl,
		       int& nErrors) ;

extern int gdr_du_print (char* str,
			 FILE* fOut,
			 gFileStat& fStat,
			 sDuOpt& duOpt,
			 int verboseLevel,
			 t_uint64 byteSize,
			 t_uint64 blockSize,
			 bool isHardLink,
			 int stripLevel,
			 bool isArg) ;

int gdr_du_dir_list (char* str,
		     FILE* fOut,
		     FILE* fRepErr,
		     gHashTriple& myHash,
		     sDuOpt& duOpt,
		     int verboseLevel,
		     gList& lPaths,
		     t_uint64& byteSize,
		     t_uint64& blockSize,
		     int& recControl,
		     int& nErrors) ;

////////////////////////////////////////////////////////////
#endif //gDIR_REC_X_H

