// gIoLists.cpp

#include <string.h>
#include <unistd.h>

#include "gIoLists.h"
////////////////////////////////////////////////////////////
int iol_probe_file_read (char* str, int bytesToProbe)
{
 int error( 0 );
 FILE* fIn;
 char smallBuf[ 128 ];

 if ( str==nil ) return -1;
 fIn = fopen( str, "rb" );
 if ( fIn==nil ) return 1;
 if ( bytesToProbe>0 ) {
     bytesToProbe = gMIN( (int)sizeof(smallBuf), bytesToProbe );
     error = read( fileno( fIn ), smallBuf, (size_t)bytesToProbe )!=bytesToProbe;
 }
 fclose( fIn );
 return error;
}

int iol_build_list_from_stream (FILE* fIn, FILE* fRepErr, gList& list)
{
 char c, sBuf[ 4096 ];
 int bufSize1( sizeof(sBuf)-1 );
 int len;

 if ( fIn==nil ) return -1;
 for ( ; fgets( sBuf, bufSize1, fIn ); ) {
     len = strlen( sBuf );
     for ( ; len>0 && ((c = sBuf[len-1])=='\r' || c=='\n'); ) {
	 sBuf[ --len ] = 0;
     }
     if ( len<=0 ) continue;
     if ( len+1>=bufSize1 ) {
	 sBuf[ 39 ] = 0;
	 if ( fRepErr ) fprintf(fRepErr,"Input buffer overflow (%d): %d\n\t'%s'...\n",bufSize1+1,len,sBuf);
	 // Line ignored: read char by char till Line-feed:
	 for ( ; fscanf( fIn, "%c", &c )==1 && c!='\n'; ) ;
	 continue;
     }

     list.Add( sBuf );
 }

 return 1;
}
////////////////////////////////////////////////////////////

