// gNormList -- Version 0.9

#include "gNormList.h"
////////////////////////////////////////////////////////////
// Static members
// ---------------------------------------------------------
// <>
////////////////////////////////////////////////////////////
int gNormList::codeSort=1;
////////////////////////////////////////////////////////////
gDevNode::gDevNode (t_uint64 aNode, int v)
    : gInt( v ),
      mask( 0 ),
      node( aNode )
{
}

gDevNode::~gDevNode ()
{
}

bool gDevNode::AddMeToList (gList& lResult)
{
 gDevNode* newObj = new gDevNode( node, c );
 ASSERTION(newObj,"newObj");
 newObj->mask = mask;
 DBGPRINT("DBG: new gDevNode [%d:%lu,mask=%d]\n",
	  newObj->c,
	  (unsigned long)newObj->node,
	  newObj->mask);
 return lResult.AppendObject( newObj );  // always true
}
////////////////////////////////////////////////////////////
gNormList::gNormList ()
{
}

gNormList::~gNormList ()
{
}

gDevNode& gNormList::DevNode (unsigned idx)
{
 ASSERTION(idx>0,"idx>0");
 ASSERTION(idx<=N(),"idx<=N()");
 gDevNode* ptrDevNode = (gDevNode*)(devNodes.GetObjectPtr( idx ));
 return *ptrDevNode;
}

unsigned gNormList::Add (char* s)
{
 DBGPRINT_MIN("DBG: gNormList::Add(%s)\n",s);
 ASSERTION(s,"s");
 ASSERTION(s[0],"s[0]!=NUL");  // NUL is the name of ASCII 0
 unsigned result( thisAddNameToList( s, codeSort ) );
 ASSERTION(result>0,"result>0");
 defDevNode.AddMeToList( devNodes );
 return result;
}

unsigned gNormList::Add (char* s, gDevNode& aDevNode)
{
 DBGPRINT_MIN("DBG: gNormList::Add(%s,{%d,0x%lX})\n",
		s,
		aDevNode.GetInt(),
		(long)aDevNode.node);
 ASSERTION(s,"s");
 ASSERTION(s[0],"s[0]!=NUL");  // NUL is the name of ASCII 0
 unsigned result( thisAddNameToList( s, codeSort ) );
 ASSERTION(result>0,"result>0");
 aDevNode.AddMeToList( devNodes );
 return result;
}

unsigned gNormList::thisAddNameToList (char* s, int doSort)
{
 gList::Add( s );
 return size;
}
////////////////////////////////////////////////////////////

