// gSumA.cpp -- Version 0.9

#include "gfile.h"
#include "gSumA.h"
#include "gNormStubs.h"
////////////////////////////////////////////////////////////
short sumA_limit_chosen (t_uint64 reqBytes, t_uint64 bSize)
{
 short result = 1;
 ASSERTION(bSize,"bSize");
 for ( ; reqBytes>4; reqBytes/=4) result++;
 return result;
}
////////////////////////////////////////////////////////////
int calc_sumA (int fd, t_uchar* buf, unsigned bufSize, t_uint64 reqBytes, t_uint64& totalBytes, t_uint16& checksum)
{
 unsigned statBytesRead;
 return
     calc_sumA_stats( fd,
		      buf,
		      bufSize,
		      reqBytes,
		      totalBytes,
		      checksum,
		      statBytesRead );
}

int calc_sumA_stats (int fd, t_uchar* buf, unsigned bufSize, t_uint64 reqBytes, t_uint64& totalBytes, t_uint16& checksum,
		     unsigned& statBytesRead)
{
 ssize_t i, bytes_read( 0 );
 unsigned r, s = 0, sPart, vPart;

 int doIoProbe = (globSumA_reqBehMask & SUMA_BEH_MASK_IoProbe)!=0;
 short limitChoose = sumA_limit_chosen( reqBytes, (t_uint64)bufSize );
 short fastChoose = limitChoose;
 unsigned calcBlocks=0, calcTotBlocks=0;

 statBytesRead = 0;

 if ( fd<0 ) return -1;

 DBGPRINT("DBG: calc_sumA: reqBytes=%llu vs %llu, limitChoose: %d\n",
	  reqBytes,
	  totalBytes,
	  (int)limitChoose);

 while ( doIoProbe ) {
     fastChoose++;
     calcTotBlocks++;
     totalBytes += (t_uint64)bytes_read;
     DBGPRINT("DBG: did read: %d [%d/%d] %s\n",bytes_read,fastChoose,limitChoose,fastChoose<=limitChoose?"\0":" (calc)");

     off_t seekCur( gns_lseek( fd, 0, SEEK_CUR ) );
     if ( fastChoose<=limitChoose && seekCur+bufSize<reqBytes ) {
	 off_t seekFwd( gns_lseek( fd, bufSize, SEEK_CUR ) );
	 off_t seekAft( gns_lseek( fd, 0, SEEK_CUR ) );
	 DBGPRINT("DBG: seekCur=%ld,seekFwd=%ld,seekAft=%ld-%u (diff=%ld)\n",
		  seekCur,
		  seekFwd,
		  seekAft,
		  bufSize,
		  seekAft-bufSize-seekCur);
	 ASSERTION(seekAft>=seekFwd,"seekAft>=seekFwd");
	 continue;
     }

     bytes_read = read( fd, buf, bufSize );
     if ( bytes_read==0 ) break;
     if ( bytes_read<0 ) return 1;

     statBytesRead += (unsigned)bytes_read;  // Just stats

     fastChoose = 0;
     for (i=0, vPart=1; i<bytes_read; i++) {
	 sPart = buf[ i ];
	 s += (sPart ^ vPart);
	 vPart <<= 1;
	 if ( vPart>256 ) vPart = 1;
     }
     calcBlocks++;
 }

 r = (s & 0xffff) + ((s & 0xffffffff) >> 16);
 checksum = (t_uint16)((r & 0xffff) + (r >> 16));

 // Question: should we avoid checksum being zero?
 //	=> if ( checksum==0 ) checksum = 0xffff	<= not used
 // No, and not in the future.

 DBGPRINT("DBG: calc_sumA: reqBytes=%llu vs %llu (Calculated=%u/%u)\n",
	  reqBytes,
	  totalBytes,
	  calcBlocks,
	  calcTotBlocks);

 return 0;
}
////////////////////////////////////////////////////////////

