// gSumLines.cpp -- Version 0.9

#include "garg.h"
#include "gstringext.h"
#include "gSumLines.h"
////////////////////////////////////////////////////////////
gSumLine::gSumLine ()
    : iValue( 0 ),
      uCheck( 0 )
{
}

gSumLine::~gSumLine ()
{
}

void gSumLine::Reset ()
{
 gString::Reset();
 iValue = 0;
 uCheck = 0;
}
////////////////////////////////////////////////////////////
int sul_string_to_checkline (gString& s, gSumLine& sResult)
{
 int error;
 t_int32 val;
 gString sTrim( s );

 sResult.Reset();
 sTrim.Trim();
 if ( sTrim.IsEmpty() || sTrim[ 1 ]=='#' ) return -1;  // Nothing to check

 if ( s[1]<'A' || s[1]>'Z' ) return 2;  // Erroneous id: not found sum-id
 if ( s[2]!=' ' && s[2]!='\t' ) return 2;  // Idem
 // Expecting something like, e.g.:
 //	A 11187 gIoLists.cpp

 sResult.iValue = (int)s[1] - (int)'A';

 gParam aParam( s.Str()+2, "\t", gParam::e_StopSplitOnFirst );
 error = gStrControl::Self().ConvertToInt32( aParam.Str(1), val );
 sResult.Set( aParam.Str(2) );
 if ( error || val<0 || val>(t_int32)MAX_UINT16_U ) return 1;

 sResult.uCheck = (t_uint16)val;
 return 0;
}

int sul_add_checkline (gString& s, gList& lResult)
{
 int error;
 gSumLine* newObj( new gSumLine );

 if ( newObj==nil ) return -1;  // Out-of-mem.

 error = sul_string_to_checkline( s, *newObj );
 if ( error ) {
     delete newObj;
     return error;
 }

 lResult.AppendObject( newObj );
 return 0;
}
////////////////////////////////////////////////////////////
char* sul_universal_set_checkline (char* str)
{
 char* strResult( str );

 if ( str==nil ) return nil;

 // Modifies input!
#ifdef gDOS_SPEC
 char c;
 for ( ; (c = *(str))!=0; ) {
     if ( c==gSLASHCHR ) {
	 *str = '/';
     }
     str++;
 }
#endif //gDOS_SPEC

 if ( strResult[0]=='.' && strResult[1]=='/' )
     strResult += 2;
 return strResult;
}
////////////////////////////////////////////////////////////

