#ifndef gXDIR_X_H
#define gXDIR_X_H

#include "gdir.h"
////////////////////////////////////////////////////////////
class gSeq : public gList {
public:
    gSeq () ;

    virtual ~gSeq () ;

    // Set methods
    virtual int InsertObject (gStorage* ptrNew) ;

    virtual int SetSize (unsigned aSize) ;

    virtual int SetStartPtr (gElem* ptrElem) ;

    virtual int SetEndPtr (gElem* ptrElem) ;

private:
    // Operators,empty
    gSeq (gSeq& ) ; //empty
    gSeq& operator= (gSeq& ) ; //empty
};
////////////////////////////////////////////////////////////
class gXFilePtr : public gString {
public:
    gXFilePtr (gFileSysName* aPtrSys=nil) ;

    virtual ~gXFilePtr () ;

    gFileSysName* ptrSys;

    // Get methods
    virtual gFileSysName* SysName () ;

    virtual char* Str () ;

    // Special methods
    virtual int AddToList (gSeq& list) ;

    int AddSysElements (gElem* ptrElem, gSeq& list) ;

private:
    // Operators,empty
    gXFilePtr (gXFilePtr& ) ; //empty
    gXFilePtr& operator= (gXFilePtr& ) ; //empty
};
////////////////////////////////////////////////////////////
class gXDir : public gDir {
public:
    gXDir (char* dName=nil, int mask=-1) ;

    virtual ~gXDir () ;

    // Public data-members
    int ioFails;

    // Get methods
    virtual gElem* StartSortedPtr () ;

    virtual gSeq* SortedList () {
	return sorted;
    }

    // Set methods
    virtual int InsertOrderedSys (gFileSysName* fSysPtr, gSeq& list) ;

    // Special methods
    virtual int SortDir (int sortCode) {
	delete sorted;
	sorted = thisSortDir( sortCode );
	return sorted==nil;
    }

protected:
    int maskValue;
    gSeq* sorted;

    gSeq* thisSortDir (int sortCode) ;

    int thisScanDirXted (int mask) ;

private:
    // Operators,empty
    gXDir (gXDir& ) ;
    gXDir& operator= (gXDir& ) ;
};
////////////////////////////////////////////////////////////

extern int gxdirSort;

extern int gxdir_string_compare (char* s1, char* s2) ;

////////////////////////////////////////////////////////////
#endif //gDIR_X_H

