#ifndef gSUP_STR_UNI_X_H
#define gSUP_STR_UNI_X_H

#include "gstringext.h"

typedef t_uint16 t_unipart;

// Preferred default path for THB is
//	usr/share/unicodeplus/unicode256.thb
// On DOS/Windowzed archs:
//	C:\Documents and Settings\All Users\Application Data\unicodeplus
// For instance, on WinXP, usually %APPDATA% points to:
//	C:\Documents and Settings\All Users\Application Data
// therefore we make 'getenv("APPDATA"): if it returns an empty string
// we use "C:\" as the prefix.

#ifdef gDOS_SPEC
#define UNI_CODE_DEF_PATH "%s"gSLASHSTR"unicodeplus"
#define UNI_DEF_INSTALLER_PREFIX "C:\\"
#else
#define UNI_CODE_DEF_PATH gSLASHSTR"usr%s"gSLASHSTR"share"gSLASHSTR"unicodeplus"
#define UNI_DEF_INSTALLER_PREFIX "\0"
#endif //~gDOS_SPEC

#define UNI_STG_ADJUST { gStorageControl::Self().StaticAlloc( "UnCode", 8 ); }

#define UNI_PART_LATIN1 8591	// means 8859-1 (Latin-1, western-european ISO8859-1)

#define UNI_PRINTABLE_LATIN (EXTUMASK_ISPRINT | EXTUMASK_ISALPHA)
////////////////////////////////////////////////////////////
// Structs
////////////////////////////////////////////////////////////
class gOptUnCode : public gControl {
public:
    gOptUnCode (char* installedPrefixThb=nil, unsigned maxUniPathLenAdd=256) ;

    // Get methods
    char* UniThbFileStr () ;

    // Public data-members
    t_int16 refCode[256];
    t_uchar refChrUse[256];
    t_int16 nRefsInvalid;

    int CheckUniTHB () ;

protected:
    gString sUniTblPathBuf;
    gString sUniTblPath;
    gString sUniTblName;

    // Internal methods
    int internalPathBuilder (char* installedPrefixThb,
			     char* defName) ;
};
////////////////////////////////////////////////////////////
// Globals
////////////////////////////////////////////////////////////
extern gOptUnCode* ptrUncode;
extern sUnCodeBin* ptrUcBin;

////////////////////////////////////////////////////////////
// Function declarations
////////////////////////////////////////////////////////////

// Helper functions
extern int unicode_read () ;
extern int unicode_leveling_latin1 () ;
extern int unicode_leveling (t_unipart part) ;

// Internal functions
extern int ucbin_read (char* thbFilename, sUnCodeBin& ucBin) ;
extern int ucbin_read_opt (gOptUnCode& unCode, sUnCodeBin& ucBin) ;

extern int ucbin_leveling (t_unipart part, bool doThbLeveling, gOptUnCode& unCode, sUnCodeBin& ucBin) ;

////////////////////////////////////////////////////////////
#endif //gSUP_STR_UNI_X_H

